/*
*/

#ifndef __H_DEFS__
#define __H_DEFS__

#include <limits.h>

/** @file
 * 
 */

#ifdef __cplusplus
#define BEGIN_DECLS extern "C" {
#else
#define BEGIN_DECLS
#endif /*__cplusplus*/


#ifdef __cplusplus
#define END_DECLS }
#else
#define END_DECLS
#endif /* __cplusplus */

BEGIN_DECLS


#ifndef FALSE
/**
 * FALSE has the absolute value of 0, it is used in as a way to represet a false
 * value. A "not" value.
 */
#define FALSE 0
#endif

#ifndef TRUE
 /**
  * TRUE represets a value that is true. A value that is "not false".
  */
#define TRUE (!FALSE)
#endif

/**
 * sboolean is the standard definition of a boolean value in SSTS.
 *
 * @sa TRUE
 * @sa FALSE
 *
 * @note
 * This is the way it is done in GLib, so it is done here too.
 */
typedef int sboolean;

/** hash type  */
typedef long hash_t;

/** spointer is a convinience typedef of void * */
typedef void* spointer;

/** sconstponter is a convinience typedef of const void * */
typedef const void* sconstponter;

/**
 * Represents different types of objects.
 *
 * @se STypeName
 */
typedef enum {
  S_TYPE_NONE = 0,
  S_TYPE_INT,
  S_TYPE_CHAR,
  S_TYPE_SHORT,
  S_TYPE_BOOLEAN,
  S_TYPE_LONG,
  S_TYPE_UINT,
  S_TYPE_UNUSED_0,
  S_TYPE_UNUSED_1,
  S_TYPE_UNUSED_2,
  S_TYPE_OBJECT,
  S_TYPE_INVALID
} SType;

/** @brief
 * The names of the SType's
 */
static const char * STypeName[] __attribute__((unused)) = {
  "NONE",
  "INT",
  "CHAR",
  "SHORT",
  "BOOLEAN",
  "LONG",
  "ULONG",
  0x0,
  0x0,
  0x0,
  "OBJECT",
  "INVALID",
  0x0,
  0x0,
};


/* Colour definitions for console prints */
#define RESET   "\033[0m"
#define BLACK   "\033[30m"      /* Black */
#define RED     "\033[31m"      /* Red */
#define GREEN   "\033[32m"      /* Green */
#define YELLOW  "\033[33m"      /* Yellow */
#define BLUE    "\033[34m"      /* Blue */
#define MAGENTA "\033[35m"      /* Magenta */
#define CYAN    "\033[36m"      /* Cyan */
#define WHITE   "\033[37m"      /* White */
#define BOLDBLACK   "\033[1m\033[30m"      /* Bold Black */
#define BOLDRED     "\033[1m\033[31m"      /* Bold Red */
#define BOLDGREEN   "\033[1m\033[32m"      /* Bold Green */
#define BOLDYELLOW  "\033[1m\033[33m"      /* Bold Yellow */
#define BOLDBLUE    "\033[1m\033[34m"      /* Bold Blue */
#define BOLDMAGENTA "\033[1m\033[35m"      /* Bold Magenta */
#define BOLDCYAN    "\033[1m\033[36m"      /* Bold Cyan */
#define BOLDWHITE   "\033[1m\033[37m"      /* Bold White */


END_DECLS

#endif
